#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s001.kuznets_kendrick_nipa_nominal_v0.RData")

setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()

# kuznets/kendrick and nipa - real
# import, merge, apply ratio
KUZ_1929_VIII <- read.csv("KUZ_1929_VIII.csv",skip=0)
tbl_1889_09_consreal_v0a <- subset(KUZ_1929_VIII,Year<=1929)
tbl_1889_09_consreal_v0a$CND_KUZ_LVL = tbl_1889_09_consreal_v0a$Perishables+tbl_1889_09_consreal_v0a$Semi.durables
tbl_1889_09_consreal_v0a$CS_KUZ_LVL = tbl_1889_09_consreal_v0a$Services+tbl_1889_09_consreal_v0a$Kendrick.Adjustment
tbl_1889_09_consreal_v0a = subset(tbl_1889_09_consreal_v0a, select=c("Year","CND_KUZ_LVL","CS_KUZ_LVL"))
tbl_1929_ratio_a <- subset(tbl_1889_09_consreal_v0a,Year==1929)
tbl_1889_09_consreal_v0a <- subset(tbl_1889_09_consreal_v0a,Year<1929)

NIPA_10103_Ann <- read.csv("10103 Ann.csv",skip=8)
tbl_1889_09_consreal_v0b <- subset(NIPA_10103_Ann,select=c("Year","Nondurable.goods","Services"))
tbl_1889_09_consreal_v0b <- rename(tbl_1889_09_consreal_v0b,c(Nondurable.goods="CND_KUZ_LVL",Services="CS_KUZ_LVL"))
kuznets_kendrick_nipa_nominal <- subset(subset(kuznets_kendrick_nipa_nominal_v0,Year==2005),select=c("NCND_KUZ_LVL","NCS_KUZ_LVL"))
tmp <- kuznets_kendrick_nipa_nominal
for(i in 1:(2012-1929)){ 	
	kuznets_kendrick_nipa_nominal <- rbind(kuznets_kendrick_nipa_nominal,tmp)
}
kuznets_kendrick_nipa_nominal$Year <- 1929:2012
tbl_1889_09_consreal_v0b <- merge(tbl_1889_09_consreal_v0b,kuznets_kendrick_nipa_nominal,by="Year")
tbl_1889_09_consreal_v0b$CND_KUZ_LVL=tbl_1889_09_consreal_v0b$CND_KUZ_LVL*tbl_1889_09_consreal_v0b$NCND_KUZ_LVL/100
tbl_1889_09_consreal_v0b$CS_KUZ_LVL=tbl_1889_09_consreal_v0b$CS_KUZ_LVL*tbl_1889_09_consreal_v0b$NCS_KUZ_LVL/100
tbl_1889_09_consreal_v0b = subset(tbl_1889_09_consreal_v0b, select=c("Year","CND_KUZ_LVL","CS_KUZ_LVL"))
tbl_1929_ratio_b <- subset(tbl_1889_09_consreal_v0b,Year==1929)

tbl_1929_ratio <- merge(tbl_1929_ratio_a,tbl_1929_ratio_b,by="Year")
tbl_1929_ratio$ratioknnd = tbl_1929_ratio$CND_KUZ_LVL.y/tbl_1929_ratio$CND_KUZ_LVL.x
tbl_1929_ratio$ratiokns = tbl_1929_ratio$CS_KUZ_LVL.y/tbl_1929_ratio$CS_KUZ_LVL.x

tbl_1929_ratio <- subset(tbl_1929_ratio,select=c("ratioknnd","ratiokns"))
tmp <- tbl_1929_ratio

# export ratios
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
sink(file="s002.tbl_1929_ratio.txt")
tbl_1929_ratio
sink(NULL)

# continue analysis
setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()

for(i in 1:(1928-1889)){ 	
	tbl_1929_ratio <- rbind(tbl_1929_ratio,tmp)
}
tbl_1929_ratio$Year <- 1889:1928

tbl_1889_09_consreal_v0a <- merge(tbl_1889_09_consreal_v0a,tbl_1929_ratio,by="Year")
tbl_1889_09_consreal_v0a$CND_KUZ_LVL = tbl_1889_09_consreal_v0a$CND_KUZ_LVL*tbl_1889_09_consreal_v0a$ratioknnd 
tbl_1889_09_consreal_v0a$CS_KUZ_LVL = tbl_1889_09_consreal_v0a$CS_KUZ_LVL*tbl_1889_09_consreal_v0a$ratiokns
tbl_1889_09_consreal_v0a = subset(tbl_1889_09_consreal_v0a, select=c("Year","CND_KUZ_LVL","CS_KUZ_LVL"))

tbl_1889_09_consreal_v0 <- rbind(tbl_1889_09_consreal_v0a,tbl_1889_09_consreal_v0b)

# import population, merge, compute per capita and growth

POP1 <- read.csv("POP1.csv",skip=5)
POP1 <- subset(rename(POP1,c(X="Year",Thousand="pop")), select=c("Year","pop"))
POP1 <- subset(POP1,Year<=2000)

POP2 <- read.csv("POP2.csv",skip=0)
POP2 <- subset(POP2,Year>=2001)
POP2$pop = POP2$pop/1000

POP <- rbind(POP1,POP2)
POP$pop = POP$pop/1000

tbl_1889_09_consreal_v0 <- merge(tbl_1889_09_consreal_v0,POP,by="Year")
tbl_1889_09_consreal_v0$CNDPER_KUZ_LVL = 1000*tbl_1889_09_consreal_v0$CND_KUZ_LVL/tbl_1889_09_consreal_v0$pop
tbl_1889_09_consreal_v0$CSPER_KUZ_LVL = 1000*tbl_1889_09_consreal_v0$CS_KUZ_LVL/tbl_1889_09_consreal_v0$pop

tbl_1889_09_consreal_v0$CNDPER_KUZ_LVL_LEAD=c(tail(tbl_1889_09_consreal_v0$CNDPER_KUZ_LVL,-1),NA)
tbl_1889_09_consreal_v0$CNDPER_KUZ_GRW=tbl_1889_09_consreal_v0$CNDPER_KUZ_LVL_LEAD/tbl_1889_09_consreal_v0$CNDPER_KUZ_LVL-1

tbl_1889_09_consreal_v0$CSPER_KUZ_LVL_LEAD=c(tail(tbl_1889_09_consreal_v0$CSPER_KUZ_LVL,-1),NA)
tbl_1889_09_consreal_v0$CSPER_KUZ_GRW=tbl_1889_09_consreal_v0$CSPER_KUZ_LVL_LEAD/tbl_1889_09_consreal_v0$CSPER_KUZ_LVL-1

tbl_1889_09_consnom <- subset(kuznets_kendrick_nipa_nominal_v0, select=c("Year","NCND_KUZ_LVL","NCS_KUZ_LVL"))
tbl_1889_09_consreal_v0 <- merge(tbl_1889_09_consreal_v0,tbl_1889_09_consnom,by="Year")

tbl_1889_09_consreal_v0$NCND_KUZ_SHR=tbl_1889_09_consreal_v0$NCND_KUZ_LVL/(tbl_1889_09_consreal_v0$NCND_KUZ_LVL+tbl_1889_09_consreal_v0$NCS_KUZ_LVL)
tbl_1889_09_consreal_v0$NCS_KUZ_SHR=tbl_1889_09_consreal_v0$NCS_KUZ_LVL/(tbl_1889_09_consreal_v0$NCND_KUZ_LVL+tbl_1889_09_consreal_v0$NCS_KUZ_LVL)

attach(tbl_1889_09_consreal_v0)
tbl_1889_09_consreal_v0$CNDSPER_KUZ_GRW[Year<=1928] <- (CNDPER_KUZ_LVL_LEAD[Year<=1928]+CSPER_KUZ_LVL_LEAD[Year<=1928])/(CNDPER_KUZ_LVL[Year<=1928]+CSPER_KUZ_LVL[Year<=1928])-1
tbl_1889_09_consreal_v0$CNDSPER_KUZ_GRW[Year>1928] <- CNDPER_KUZ_GRW[Year>1928]*NCND_KUZ_SHR[Year>1928]+CSPER_KUZ_GRW[Year>1928]*NCS_KUZ_SHR[Year>1928]
detach(tbl_1889_09_consreal_v0)

tbl_1889_09_consreal_v0$CND_KUZ_LVL_LEAD=c(tail(tbl_1889_09_consreal_v0$CND_KUZ_LVL,-1),NA)
tbl_1889_09_consreal_v0$CND_KUZ_GRW=tbl_1889_09_consreal_v0$CND_KUZ_LVL_LEAD/tbl_1889_09_consreal_v0$CND_KUZ_LVL-1

tbl_1889_09_consreal_v0$CS_KUZ_LVL_LEAD=c(tail(tbl_1889_09_consreal_v0$CS_KUZ_LVL,-1),NA)
tbl_1889_09_consreal_v0$CS_KUZ_GRW=tbl_1889_09_consreal_v0$CS_KUZ_LVL_LEAD/tbl_1889_09_consreal_v0$CS_KUZ_LVL-1

tbl_1889_09_consreal_v0 <- subset(tbl_1889_09_consreal_v0,select=c("Year","CND_KUZ_LVL","CS_KUZ_LVL","pop","CNDPER_KUZ_LVL","CSPER_KUZ_LVL","CNDPER_KUZ_GRW","CSPER_KUZ_GRW","CNDSPER_KUZ_GRW","CND_KUZ_GRW","CS_KUZ_GRW"))

# import Mehra-Prescott for comparison
MP85 <- read.csv("Mehra_Prescott_1985.csv",skip=1)
MP85 <- subset(MP85, select=c("Year","C"))
MP85$C_LEAD=c(tail(MP85$C,-1),NA)
MP85$MP85=MP85$C_LEAD/MP85$C-1
MP85 <- subset(MP85,Year<=1928)
MP85 <- subset(MP85, select=c("Year","MP85"))

tbl_1889_09_consreal_v0 <- merge(tbl_1889_09_consreal_v0,MP85,by="Year",all.x=TRUE,all.y=TRUE)

tbl_1889_09_consreal_v0$MP85[tbl_1889_09_consreal_v0$Year>=1929] <- tbl_1889_09_consreal_v0$CNDSPER_KUZ_GRW[tbl_1889_09_consreal_v0$Year>=1929] 

# kuznets/kendrick and nipa - real
# without separately applying ratio of non-durables and services
KUZ_1929_VIII <- read.csv("KUZ_1929_VIII.csv",skip=0)
KUZ_1929_VIII <- subset(KUZ_1929_VIII,Year<=1929)
KUZ_1929_VIII$CND_KUZ_LVL = KUZ_1929_VIII$Perishables+KUZ_1929_VIII$Semi.durables
KUZ_1929_VIII$CS_KUZ_LVL = KUZ_1929_VIII$Services+KUZ_1929_VIII$Kendrick.Adjustment
KUZ_1929_VIII = subset(KUZ_1929_VIII, select=c("Year","CND_KUZ_LVL","CS_KUZ_LVL"))
KUZ_1929_VIII <- subset(KUZ_1929_VIII,Year<=1929)

KUZ_1929_VIII$CNDS_KUZ_LVL = KUZ_1929_VIII$CND_KUZ_LVL+KUZ_1929_VIII$CS_KUZ_LVL
KUZ_1929_VIII <- merge(KUZ_1929_VIII,POP,by="Year")
KUZ_1929_VIII$CNDSPER_KUZ_LVL = 1000*KUZ_1929_VIII$CNDS_KUZ_LVL/KUZ_1929_VIII$pop

KUZ_1929_VIII$CNDSPER_KUZ_LVL_LEAD=c(tail(KUZ_1929_VIII$CNDSPER_KUZ_LVL,-1),NA)
KUZ_1929_VIII$CNDSPER_KUZ_GRW1=KUZ_1929_VIII$CNDSPER_KUZ_LVL_LEAD/KUZ_1929_VIII$CNDSPER_KUZ_LVL-1
KUZ_1929_VIII <- subset(KUZ_1929_VIII, select=c("Year","CNDSPER_KUZ_GRW1"))

tbl_1889_09_consreal_v0 <- merge(tbl_1889_09_consreal_v0,KUZ_1929_VIII,by="Year",all.x=TRUE,all.y=TRUE)

tbl_1889_09_consreal_v0$CNDSPER_KUZ_GRW1[tbl_1889_09_consreal_v0$Year>=1929] <- tbl_1889_09_consreal_v0$CNDSPER_KUZ_GRW[tbl_1889_09_consreal_v0$Year>=1929] 

# export results
kuznets_kendrick_nipa_real_v0 <- tbl_1889_09_consreal_v0

setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
write.table(kuznets_kendrick_nipa_real_v0,"s002.consumption_traditional.csv",sep=",")
save(kuznets_kendrick_nipa_real_v0,file="s002.kuznets_kendrick_nipa_real_v0.RData")
