#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s003.shaw_perishables.RData")

# incorporate the value added by transportation and distribution, adjusted for inventory changes - based on kuznets methodology
shaw_tbl_ii_1_food <- subset(shaw_perishables,select=c("Year","cons1a","cons1b","cons_real1a","cons_real1b"))
shaw_tbl_ii_1_food$cons1 = 1/1000*(shaw_tbl_ii_1_food$cons1a + shaw_tbl_ii_1_food$cons1b)
shaw_tbl_ii_1_food$cons_real1 = 1/1000*(shaw_tbl_ii_1_food$cons_real1a + shaw_tbl_ii_1_food$cons_real1b)
shaw_tbl_ii_1_food$cons_real1_retail = 1.5001*shaw_tbl_ii_1_food$cons_real1 # see notes to column 3 and lines 1-13, table ii 1, kuznets (1946)
shaw_tbl_ii_1_food$cons_real1_retail_LEAD=c(tail(shaw_tbl_ii_1_food$cons_real1_retail,-1),NA)
shaw_tbl_ii_1_food$net_chg_inventory <- (shaw_tbl_ii_1_food$cons_real1_retail_LEAD-shaw_tbl_ii_1_food$cons_real1_retail)

shaw_tbl_1899_1908 <- subset(shaw_tbl_ii_1_food,Year>=1899 & Year<=1908)
shaw_tbl_decade_avg_1899_1908 <- mean(shaw_tbl_1899_1908)
shaw_tbl_1904_1913 <- subset(shaw_tbl_ii_1_food,Year>=1904 & Year<=1913)
shaw_tbl_decade_avg_1904_1913 <- mean(shaw_tbl_1904_1913)
shaw_tbl_1909_1918 <- subset(shaw_tbl_ii_1_food,Year>=1909 & Year<=1918)
shaw_tbl_decade_avg_1909_1918 <- mean(shaw_tbl_1909_1918)
shaw_tbl_decade_avg <- data.frame(rbind(shaw_tbl_decade_avg_1899_1908,shaw_tbl_decade_avg_1904_1913,shaw_tbl_decade_avg_1909_1918))
attach(shaw_tbl_decade_avg)
shaw_tbl_decade_avg$cons_real1_retail = 1.5001*cons_real1 # see notes to column 3 and lines 1-13, table ii 1, kuznets (1946)
shaw_tbl_decade_avg$net_chg_inventory = 0.1587*net_chg_inventory # see notes to column 4 and lines 1-13, table ii 1, kuznets (1946)
detach(shaw_tbl_decade_avg)
attach(shaw_tbl_decade_avg)
shaw_tbl_decade_avg$cons_real1_final = cons_real1_retail - net_chg_inventory
shaw_tbl_decade_avg$price1 = 100*cons1/cons_real1 
detach(shaw_tbl_decade_avg)
shaw_tbl_decade_avg$cons1_final = (1/100)*(shaw_tbl_decade_avg$cons_real1_final*shaw_tbl_decade_avg$price1)
shaw_tbl_decade_avg$ratios = shaw_tbl_decade_avg$cons_real1_final/shaw_tbl_decade_avg$cons_real1

shaw_tbl_r_28_food <- subset(shaw_perishables,select=c("Year","cons1a","cons1b","cons_real1a","cons_real1b"))
shaw_tbl_r_28_food$cons1 = 1/1000*(shaw_tbl_r_28_food$cons1a + shaw_tbl_r_28_food$cons1b)
shaw_tbl_r_28_food$cons_real1 = 1/1000*(shaw_tbl_r_28_food$cons_real1a + shaw_tbl_r_28_food$cons_real1b)

extrap <- lm(shaw_tbl_decade_avg$ratios ~ shaw_tbl_decade_avg$Year)
shaw_tbl_r_28_food$ratio_extrap <- extrap$coefficients[[2]]*shaw_tbl_r_28_food$Year+extrap$coefficients[[1]]
shaw_tbl_r_28_food$cons_real_final_var_i_1 <- shaw_tbl_r_28_food$cons_real1*shaw_tbl_r_28_food$ratio_extrap

shaw_tbl_r_28_food$cons_real_final_var_iii_1 <- mean(c(27245,26518,26497))/mean(c(27963,27456,26234))*shaw_tbl_r_28_food$cons_real_final_var_i_1 # ratio of: (1) average flow of perishable goods to consumers at cost to them, 1929 prices, variant iii, for 1929-1931; to (2) average flow of perishable goods to consumers at cost to them, 1929 prices, variant i, for 1929-1931. for flow of perishable goods to consumers at cost to them, 1929 prices, variant iii and i, see table t-7, pg. 13, technical tables underlying series in capital in american economy: its formation anf financing.

shaw_tbl_r_28_food$price1=shaw_tbl_r_28_food$cons1/shaw_tbl_r_28_food$cons_real1
shaw_tbl_r_28_food$cons_final_var_iii_1=shaw_tbl_r_28_food$price1*shaw_tbl_r_28_food$cons_real_final_var_iii_1

# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
save(shaw_tbl_r_28_food,file="s004.shaw_tbl_r_28_food.RData")

