#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s004.shaw_tbl_r_28_food.RData")
load("s005.farm_food.RData")
setwd(paste(rootpath,"Analysis/Code",sep=""))
getwd()
source("hp.r")

# create (1) hp-trend for kuznets food series, (2) hp-trend and deviations for consumption of farm food, (3) new food series  
food_1899_1918 <- subset(shaw_tbl_r_28_food,select=c("Year","cons_real_final_var_iii_1","cons_final_var_iii_1"))
attach(food_1899_1918)
food_1899_1918$cons_real_final_var_iii_1_log <- log(cons_real_final_var_iii_1)
food_1899_1918$cons_final_var_iii_1_log <- log(cons_final_var_iii_1)
detach(food_1899_1918)
attach(food_1899_1918)
food_1899_1918$cons_real_final_var_iii_1_hp <- hp(cons_real_final_var_iii_1_log,10000) 
food_1899_1918$cons_final_var_iii_1_hp <- hp(cons_final_var_iii_1_log,10000) 
detach(food_1899_1918)

food_1899_1918a <- subset(farm_food,select=c("Year","cons_farm_food_nom","cons_farm_food_real"))
food_1899_1918a <- subset(food_1899_1918a,Year <=1919)
food_1899_1918a$cons_farm_food_real <- 1000*food_1899_1918a$cons_farm_food_real
food_1899_1918a$cons_farm_food_nom <- 1000*food_1899_1918a$cons_farm_food_nom
attach(food_1899_1918a)
food_1899_1918a$cons_farm_food_real_log <- log(cons_farm_food_real)
food_1899_1918a$cons_farm_food_nom_log <- log(cons_farm_food_nom)
detach(food_1899_1918a)
attach(food_1899_1918a)
food_1899_1918a$cons_farm_food_real_hp <- hp(cons_farm_food_real_log,10000) 
food_1899_1918a$cons_farm_food_nom_hp <- hp(cons_farm_food_nom_log,10000) 
detach(food_1899_1918a)
attach(food_1899_1918a)
food_1899_1918a$cons_farm_food_real_dev <- cons_farm_food_real_log-cons_farm_food_real_hp 
food_1899_1918a$cons_farm_food_nom_dev <- cons_farm_food_nom_log-cons_farm_food_nom_hp 
detach(food_1899_1918a)

food_1899_1918 <- merge(food_1899_1918,food_1899_1918a,by="Year")
attach(food_1899_1918)
food_1899_1918$food_comp_real_new <- exp(cons_real_final_var_iii_1_hp+cons_farm_food_real_dev)
food_1899_1918$food_comp_nom_new <- exp(cons_final_var_iii_1_hp+cons_farm_food_nom_dev)
detach(food_1899_1918)
food_1899_1918 <- subset(food_1899_1918,select=c("Year","food_comp_real_new","food_comp_nom_new"))

# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
save(food_1899_1918,file="s006.food_1899_1918.RData")

