#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
library(gdata)
installXLSXsupport(perl="C:/cygwin/bin/perl.exe")

setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s006.food_1899_1918.RData")
load("s007.shaw_tbl_r_28_nonfood.RData")
load("s001.kuznets_kendrick_nipa_nominal_v0.RData")

setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()
# import, merge, apply ratio
Kuz_Curr_VIII <- read.csv("Kuz_Curr_VIII.csv",skip=0)
tbl_1899_09_consnom_v1a <- subset(Kuz_Curr_VIII,Year<=1929)
tbl_1899_09_consnom_v1a <- merge(tbl_1899_09_consnom_v1a,subset(food_1899_1918,select=c("Year","food_comp_nom_new")),by="Year",all.x=TRUE,all.y=TRUE)
tbl_1899_09_consnom_v1a <- merge(tbl_1899_09_consnom_v1a,subset(shaw_tbl_r_28_nonfood,select=c("Year","cons_final_var_iii_2_5a")),by="Year",all.x=TRUE,al.y=TRUE)
attach(tbl_1899_09_consnom_v1a)
tbl_1899_09_consnom_v1a$NCND_AZE_LVL[Year<=1929 & Year>=1919] = (1/1000)*(Perishables[Year<=1929 & Year>=1919]+Semi.durables[Year<=1929 & Year>=1919])
tbl_1899_09_consnom_v1a$NCND_AZE_LVL[Year<=1918] = (1/1000)*(food_comp_nom_new[Year<=1918]+cons_final_var_iii_2_5a[Year<=1918]+Semi.durables[Year<=1918])
detach(tbl_1899_09_consnom_v1a)
tbl_1899_09_consnom_v1a$NCS_AZE_LVL = NA
tbl_1899_09_consnom_v1a = subset(tbl_1899_09_consnom_v1a, select=c("Year","NCND_AZE_LVL","NCS_AZE_LVL"))
tbl_1929_ratio_a <- subset(tbl_1899_09_consnom_v1a,Year==1929)
tbl_1899_09_consnom_v1a <- subset(tbl_1899_09_consnom_v1a,Year<1929)

NIPA_10105_Ann <- read.csv("10105 Ann.csv",skip=8)
tbl_1899_09_consnom_v1b <- subset(NIPA_10105_Ann,select=c("Year","Nondurable.goods","Services"))
tbl_1899_09_consnom_v1b <- rename(tbl_1899_09_consnom_v1b,c(Nondurable.goods="NCND_AZE_LVL",Services="NCS_AZE_LVL"))
tbl_1929_ratio_b <- subset(tbl_1899_09_consnom_v1b,Year==1929)
tbl_1929_ratio <- merge(tbl_1929_ratio_a,tbl_1929_ratio_b,by="Year")
tbl_1929_ratio$ratioknnd = tbl_1929_ratio$NCND_AZE_LVL.y/tbl_1929_ratio$NCND_AZE_LVL.x
tbl_1929_ratio$ratiokns = tbl_1929_ratio$NCS_AZE_LVL.y/tbl_1929_ratio$NCS_AZE_LVL.x
tbl_1929_ratio <- subset(tbl_1929_ratio,select=c("ratioknnd","ratiokns"))
tmp <- tbl_1929_ratio

# export ratios
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
sink(file="s008.tbl_1929_ratio.txt")
tbl_1929_ratio
sink(NULL)

# continue analysis
setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()


for(i in 1:(1928-1899)){
	tbl_1929_ratio <- rbind(tbl_1929_ratio,tmp)
}
tbl_1929_ratio$Year <- 1899:1928

tbl_1899_09_consnom_v1a <- merge(tbl_1899_09_consnom_v1a,tbl_1929_ratio,by="Year")
tbl_1899_09_consnom_v1a$NCND_AZE_LVL = tbl_1899_09_consnom_v1a$NCND_AZE_LVL*tbl_1899_09_consnom_v1a$ratioknnd 
tbl_1899_09_consnom_v1a$NCS_AZE_LVL = tbl_1899_09_consnom_v1a$NCS_AZE_LVL*tbl_1899_09_consnom_v1a$ratiokns
tbl_1899_09_consnom_v1a = subset(tbl_1899_09_consnom_v1a, select=c("Year","NCND_AZE_LVL","NCS_AZE_LVL"))

tbl_1899_09_consnom_v1 <- rbind(tbl_1899_09_consnom_v1a,tbl_1899_09_consnom_v1b)

# import population, merge, compute per capita and growth

POP1 <- read.csv("POP1.csv",skip=5)
POP1 <- subset(rename(POP1,c(X="Year",Thousand="pop")), select=c("Year","pop"))
POP1 <- subset(POP1,Year<=2000)

POP2 <- read.csv("POP2.csv",skip=0)
POP2 <- subset(POP2,Year>=2001)
POP2$pop = POP2$pop/1000

POP <- rbind(POP1,POP2)
POP$pop = POP$pop/1000

tbl_1899_09_consnom_v1 <- merge(tbl_1899_09_consnom_v1,POP,by="Year")
tbl_1899_09_consnom_v1$NCNDPER_AZE_LVL = 1000*tbl_1899_09_consnom_v1$NCND_AZE_LVL/tbl_1899_09_consnom_v1$pop

tbl_1899_09_consnom_v1$NCNDPER_AZE_LVL_LEAD=c(tail(tbl_1899_09_consnom_v1$NCNDPER_AZE_LV,-1),NA)
tbl_1899_09_consnom_v1$NCNDPER_AZE_GRW=tbl_1899_09_consnom_v1$NCNDPER_AZE_LVL_LEAD/tbl_1899_09_consnom_v1$NCNDPER_AZE_LVL-1

tbl_1899_09_consnom_v1 <- subset(tbl_1899_09_consnom_v1,select=c("Year","NCND_AZE_LVL","NCS_AZE_LVL","pop","NCNDPER_AZE_LVL","NCNDPER_AZE_LVL_LEAD","NCNDPER_AZE_GRW"))
azeredo_nipa_nominal_v1 <- tbl_1899_09_consnom_v1

# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
save(azeredo_nipa_nominal_v1,file="s008.azeredo_nipa_nominal_v1.RData")

