#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s006.food_1899_1918.RData")
load("s007.shaw_tbl_r_28_nonfood.RData")
load("s008.azeredo_nipa_nominal_v1.RData")

setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()
# import, merge, apply ratio
Kuz_1929_VIII <- read.csv("Kuz_1929_VIII.csv",skip=0)
tbl_1899_09_consreal_v1a <- subset(Kuz_1929_VIII,Year<=1929)
tbl_1899_09_consreal_v1a <- merge(tbl_1899_09_consreal_v1a,subset(food_1899_1918,select=c("Year","food_comp_real_new")),by="Year",all.x=TRUE,all.y=TRUE)
tbl_1899_09_consreal_v1a <- merge(tbl_1899_09_consreal_v1a,subset(shaw_tbl_r_28_nonfood,select=c("Year","cons_real_final_var_iii_2_5a")),by="Year",all.x=TRUE,al.y=TRUE)
attach(tbl_1899_09_consreal_v1a)
tbl_1899_09_consreal_v1a$CND_AZE_LVL[Year<=1929 & Year>=1919] = (1/1000)*(Perishables[Year<=1929 & Year>=1919]+Semi.durables[Year<=1929 & Year>=1919])
tbl_1899_09_consreal_v1a$CND_AZE_LVL[Year<=1918] = (1/1000)*(food_comp_real_new[Year<=1918]+cons_real_final_var_iii_2_5a[Year<=1918]+Semi.durables[Year<=1918])
detach(tbl_1899_09_consreal_v1a)
tbl_1899_09_consreal_v1a$CS_AZE_LVL = NA
tbl_1899_09_consreal_v1a = subset(tbl_1899_09_consreal_v1a, select=c("Year","CND_AZE_LVL","CS_AZE_LVL"))
tbl_1929_ratio_a <- subset(tbl_1899_09_consreal_v1a,Year==1929)
tbl_1899_09_consreal_v1a <- subset(tbl_1899_09_consreal_v1a,Year<1929)

NIPA_10103_Ann <- read.csv("10103 Ann.csv",skip=8)
tbl_1899_09_consreal_v1b <- subset(NIPA_10103_Ann,select=c("Year","Nondurable.goods","Services"))
tbl_1899_09_consreal_v1b <- rename(tbl_1899_09_consreal_v1b,c(Nondurable.goods="CND_AZE_LVL",Services="CS_AZE_LVL"))

azeredo_nipa_nominal <- subset(subset(azeredo_nipa_nominal_v1,Year==2005),select=c("NCND_AZE_LVL","NCS_AZE_LVL"))
tmp <- azeredo_nipa_nominal
for(i in 1:(2012-1929)){ 	
	azeredo_nipa_nominal <- rbind(azeredo_nipa_nominal,tmp)
}
azeredo_nipa_nominal$Year <- 1929:2012
tbl_1899_09_consreal_v1b <- merge(tbl_1899_09_consreal_v1b,azeredo_nipa_nominal,by="Year")
tbl_1899_09_consreal_v1b$CND_AZE_LVL=tbl_1899_09_consreal_v1b$CND_AZE_LVL*tbl_1899_09_consreal_v1b$NCND_AZE_LVL/100
tbl_1899_09_consreal_v1b$CS_AZE_LVL=tbl_1899_09_consreal_v1b$CS_AZE_LVL*tbl_1899_09_consreal_v1b$NCS_AZE_LVL/100
tbl_1899_09_consreal_v1b = subset(tbl_1899_09_consreal_v1b, select=c("Year","CND_AZE_LVL","CS_AZE_LVL"))

tbl_1929_ratio_b <- subset(tbl_1899_09_consreal_v1b,Year==1929)
tbl_1929_ratio <- merge(tbl_1929_ratio_a,tbl_1929_ratio_b,by="Year")
tbl_1929_ratio$ratioknnd = tbl_1929_ratio$CND_AZE_LVL.y/tbl_1929_ratio$CND_AZE_LVL.x
tbl_1929_ratio$ratiokns = tbl_1929_ratio$CS_AZE_LVL.y/tbl_1929_ratio$CS_AZE_LVL.x
tbl_1929_ratio <- subset(tbl_1929_ratio,select=c("ratioknnd","ratiokns"))
tmp <- tbl_1929_ratio

# export ratios
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
sink(file="s009.tbl_1929_ratio.txt")
tbl_1929_ratio
sink(NULL)

# continue analysis
setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()

for(i in 1:(1928-1899)){
	tbl_1929_ratio <- rbind(tbl_1929_ratio,tmp)
}
tbl_1929_ratio$Year <- 1899:1928

tbl_1899_09_consreal_v1a <- merge(tbl_1899_09_consreal_v1a,tbl_1929_ratio,by="Year")
tbl_1899_09_consreal_v1a$CND_AZE_LVL = tbl_1899_09_consreal_v1a$CND_AZE_LVL*tbl_1899_09_consreal_v1a$ratioknnd 
tbl_1899_09_consreal_v1a$CS_AZE_LVL = tbl_1899_09_consreal_v1a$CS_AZE_LVL*tbl_1899_09_consreal_v1a$ratiokns
tbl_1899_09_consreal_v1a = subset(tbl_1899_09_consreal_v1a, select=c("Year","CND_AZE_LVL","CS_AZE_LVL"))

tbl_1899_09_consreal_v1 <- rbind(tbl_1899_09_consreal_v1a,tbl_1899_09_consreal_v1b)

# import population, merge, compute per capita and growth

POP1 <- read.csv("POP1.csv",skip=5)
POP1 <- subset(rename(POP1,c(X="Year",Thousand="pop")), select=c("Year","pop"))
POP1 <- subset(POP1,Year<=2000)

POP2 <- read.csv("POP2.csv",skip=0)
POP2 <- subset(POP2,Year>=2001)
POP2$pop = POP2$pop/1000

POP <- rbind(POP1,POP2)
POP$pop = POP$pop/1000

tbl_1899_09_consreal_v1 <- merge(tbl_1899_09_consreal_v1,POP,by="Year")
tbl_1899_09_consreal_v1$CNDPER_AZE_LVL = 1000*tbl_1899_09_consreal_v1$CND_AZE_LVL/tbl_1899_09_consreal_v1$pop
tbl_1899_09_consreal_v1$CSPER_AZE_LVL = 1000*tbl_1899_09_consreal_v1$CS_AZE_LVL/tbl_1899_09_consreal_v1$pop

tbl_1899_09_consreal_v1$CNDPER_AZE_LVL_LEAD=c(tail(tbl_1899_09_consreal_v1$CNDPER_AZE_LV,-1),NA)
tbl_1899_09_consreal_v1$CNDPER_AZE_GRW=tbl_1899_09_consreal_v1$CNDPER_AZE_LVL_LEAD/tbl_1899_09_consreal_v1$CNDPER_AZE_LVL-1

tbl_1899_09_consreal_v1$CSPER_AZE_LVL_LEAD=c(tail(tbl_1899_09_consreal_v1$CSPER_AZE_LV,-1),NA)
tbl_1899_09_consreal_v1$CSPER_AZE_GRW=tbl_1899_09_consreal_v1$CSPER_AZE_LVL_LEAD/tbl_1899_09_consreal_v1$CSPER_AZE_LVL-1

tbl_1899_09_consreal <- subset(azeredo_nipa_nominal_v1, select=c("Year","NCND_AZE_LVL","NCS_AZE_LVL"))
tbl_1899_09_consreal_v1 <- merge(tbl_1899_09_consreal_v1,tbl_1899_09_consreal,by="Year")

tbl_1899_09_consreal_v1$NCND_AZE_SHR=tbl_1899_09_consreal_v1$NCND_AZE_LVL/(tbl_1899_09_consreal_v1$NCND_AZE_LVL+tbl_1899_09_consreal_v1$NCS_AZE_LVL)
tbl_1899_09_consreal_v1$NCS_AZE_SHR=tbl_1899_09_consreal_v1$NCS_AZE_LVL/(tbl_1899_09_consreal_v1$NCND_AZE_LVL+tbl_1899_09_consreal_v1$NCS_AZE_LVL)

attach(tbl_1899_09_consreal_v1)
tbl_1899_09_consreal_v1$CNDSPER_AZE_GRW[Year<=1928] <- (CNDPER_AZE_LVL_LEAD[Year<=1928]+CSPER_AZE_LVL_LEAD[Year<=1928])/(CNDPER_AZE_LVL[Year<=1928]+CSPER_AZE_LVL[Year<=1928])-1
tbl_1899_09_consreal_v1$CNDSPER_AZE_GRW[Year>1928] <- CNDPER_AZE_GRW[Year>1928]*NCND_AZE_SHR[Year>1928]+CSPER_AZE_GRW[Year>1928]*NCS_AZE_SHR[Year>1928]
detach(tbl_1899_09_consreal_v1)

tbl_1899_09_consreal_v1 <- subset(tbl_1899_09_consreal_v1,select=c("Year","CND_AZE_LVL","CS_AZE_LVL","pop","CNDPER_AZE_LVL","CSPER_AZE_LVL","CNDPER_AZE_GRW","CSPER_AZE_GRW","CNDSPER_AZE_GRW"))

azeredo_nipa_real_v1 <- tbl_1899_09_consreal_v1

# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
save(azeredo_nipa_real_v1,file="s009.azeredo_nipa_real_v1.RData")

