#!/usr/bin/env Rscript
rm(list=ls()[!grepl('^rootpath$',ls())])
library(plyr)
library(reshape)
library(gdata)
setwd(paste(rootpath,"Analysis/Code",sep=""))
getwd()
source("hp.r")

setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s008.azeredo_nipa_nominal_v1.RData")
current_prices_backcasting <- subset(azeredo_nipa_nominal_v1,select=c("Year","NCND_AZE_LVL"))
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_LOG = log(NCND_AZE_LVL)
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_HP = hp(NCND_AZE_LOG,100)
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_DIFF = NCND_AZE_LOG-NCND_AZE_HP
detach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_DIFF_LEAD=c(tail(current_prices_backcasting$NCND_AZE_DIFF,-1),NA)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_FIRSTDIFF = NCND_AZE_DIFF_LEAD - NCND_AZE_DIFF
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1 = c(NA,head(NCND_AZE_FIRSTDIFF,-1))
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2 = c(NA,head(NCND_AZE_FIRSTDIFF_LAG1,-1))
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1[Year==2012] <- NA
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2[Year==2012] <- NA
detach(current_prices_backcasting)
m1 <- mean(current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1,na.rm=TRUE)
m2 <- mean(current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2,na.rm=TRUE)
attach(current_prices_backcasting)
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1[Year==1899] <- m1
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2[Year==1900] <- m1
current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2[Year==1899] <- m2
detach(current_prices_backcasting)

current_prices_backcasting1 <- subset(azeredo_nipa_nominal_v1,select=c("Year","NCS_AZE_LVL"))
current_prices_backcasting1 <- subset(current_prices_backcasting1,Year>=1929)
attach(current_prices_backcasting1)
current_prices_backcasting1$NCS_AZE_LOG = log(NCS_AZE_LVL)
detach(current_prices_backcasting1)
attach(current_prices_backcasting1)
current_prices_backcasting1$NCS_AZE_HP = hp(NCS_AZE_LOG,100)
detach(current_prices_backcasting1)
attach(current_prices_backcasting1)
current_prices_backcasting1$NCS_AZE_DIFF = NCS_AZE_LOG-NCS_AZE_HP
detach(current_prices_backcasting1)
current_prices_backcasting1$NCS_AZE_DIFF_LEAD=c(tail(current_prices_backcasting1$NCS_AZE_DIFF,-1),NA)
attach(current_prices_backcasting1)
current_prices_backcasting1$NCS_AZE_FIRSTDIFF = NCS_AZE_DIFF_LEAD - NCS_AZE_DIFF
detach(current_prices_backcasting1)

current_prices_backcasting <- merge(current_prices_backcasting,current_prices_backcasting1,by="Year",all.x=TRUE,all.y=TRUE)

service_nom_regression <- lm(current_prices_backcasting$NCS_AZE_FIRSTDIFF ~ current_prices_backcasting$NCND_AZE_FIRSTDIFF + current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1 + current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2)

current_prices_backcasting$NCS_AZE_FIRSTDIFF_HAT <- service_nom_regression$coefficient[[1]]+service_nom_regression$coefficient[[2]]*current_prices_backcasting$NCND_AZE_FIRSTDIFF+service_nom_regression$coefficient[[3]]*current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG1+service_nom_regression$coefficient[[4]]*current_prices_backcasting$NCND_AZE_FIRSTDIFF_LAG2
attach(current_prices_backcasting)
current_prices_backcasting$NCS_AZE_FIRSTDIFF[Year<1929] <- NCS_AZE_FIRSTDIFF_HAT[Year<1929]
detach(current_prices_backcasting)
for (t in (31:2)){
	current_prices_backcasting$NCS_AZE_DIFF[[t-1]] <- current_prices_backcasting$NCS_AZE_DIFF[[t]] - current_prices_backcasting$NCS_AZE_FIRSTDIFF[[t-1]] 
}

# import kuznets 1899
setwd(paste(rootpath,"Analysis/Input",sep=""))
getwd()
Kuz_Curr_VIII <- read.csv("Kuz_Curr_VIII.csv",skip=0)
Kuz_Curr_VIII <- subset(Kuz_Curr_VIII,Year==1899 | Year==1929)
attach(Kuz_Curr_VIII)
Kuz_Curr_VIII$NCS_KUZ_LVL <- (Services+Kendrick.Adjustment)/1000
detach(Kuz_Curr_VIII)
Kuz_Curr_VIII <- subset(Kuz_Curr_VIII,select=c("Year","NCS_KUZ_LVL"))

# import dewhurst service data for 1909, 1914, 1919, 1921, 1923, 1924, 1925, 1927, 1929
PG965 <- read.xls("Dewhurst.xls",sheet="PG965",perl="C:/cygwin/bin/perl.exe")
PG968 <- read.xls("Dewhurst.xls",sheet="PG968",perl="C:/cygwin/bin/perl.exe")
PG971 <- read.xls("Dewhurst.xls",sheet="PG971",perl="C:/cygwin/bin/perl.exe")
PG974 <- read.xls("Dewhurst.xls",sheet="PG974",perl="C:/cygwin/bin/perl.exe")
PG977 <- read.xls("Dewhurst.xls",sheet="PG977",perl="C:/cygwin/bin/perl.exe")
PG980 <- read.xls("Dewhurst.xls",sheet="PG980",perl="C:/cygwin/bin/perl.exe")
dewhurst <- data.frame()
dewhurst <- rbind(dewhurst,PG965)
dewhurst <- rbind(dewhurst,PG968)
dewhurst <- rbind(dewhurst,PG971)
dewhurst <- rbind(dewhurst,PG974)
dewhurst <- rbind(dewhurst,PG977)
dewhurst <- rbind(dewhurst,PG980)

names_drop <- names(dewhurst) %in% c("Comment","Section","Class.of.Expenditure")
dewhurst <- dewhurst[!names_drop]
attach(dewhurst)
dewhurst_byclass <- aggregate(dewhurst[,-1],by=list(Include..I...Exclude..E.),FUN=sum,na.rm=TRUE)
detach(dewhurst)
dewhurst_byclass <- subset(dewhurst_byclass,Group.1 != "E")
names_drop <- names(dewhurst_byclass) %in% c("Group.1","X1930","X1931","X1932")
dewhurst_byclass <- dewhurst_byclass[!names_drop]
dewhurst_byclass$Group="ALL"
attach(dewhurst_byclass)
dewhurst_wide <- aggregate(dewhurst_byclass[,-9],by=list(Group),FUN=sum,na.rm=TRUE)
detach(dewhurst_byclass)

dewhurst_long <- reshape(dewhurst_wide,v.names="NCS_DEW_LVL",varying=list(c("X1909","X1914","X1919","X1921","X1923","X1925","X1927","X1929")),idvar="Group.1",direction="long")
dewhurst_long$Year <- c(1909,1914,1919,1921,1923,1925,1927,1929)
names_drop <- names(dewhurst_long) %in% c("Group.1","time")
dewhurst_long <- dewhurst_long[!names_drop]

current_prices_backcasting <- merge(current_prices_backcasting,Kuz_Curr_VIII,by="Year",all.x=TRUE,all.y=TRUE)
current_prices_backcasting <- merge(current_prices_backcasting,dewhurst_long,by="Year",all.x=TRUE,all.y=TRUE)
current_prices_backcasting$NCS_DEW_LVL <- current_prices_backcasting$NCS_DEW_LVL
attach(current_prices_backcasting)
current_prices_backcasting$NCS_AZE_LVL[Year==1899] <- (NCS_AZE_LVL[Year==1929]/NCS_KUZ_LVL[Year==1929])*NCS_KUZ_LVL[Year==1899]
current_prices_backcasting$NCS_AZE_LVL[Year==1909] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1909]
current_prices_backcasting$NCS_AZE_LVL[Year==1914] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1914]
current_prices_backcasting$NCS_AZE_LVL[Year==1919] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1919]
current_prices_backcasting$NCS_AZE_LVL[Year==1921] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1921]
current_prices_backcasting$NCS_AZE_LVL[Year==1923] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1923]
current_prices_backcasting$NCS_AZE_LVL[Year==1925] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1925]
current_prices_backcasting$NCS_AZE_LVL[Year==1927] <- (1/1000)*(NCS_AZE_LVL[Year==1929]/((1/1000)*NCS_DEW_LVL[Year==1929]))*NCS_DEW_LVL[Year==1927]
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCS_AZE_LOG[Year==1899] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1899])
current_prices_backcasting$NCS_AZE_LOG[Year==1909] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1909])
current_prices_backcasting$NCS_AZE_LOG[Year==1914] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1914])
current_prices_backcasting$NCS_AZE_LOG[Year==1919] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1919])
current_prices_backcasting$NCS_AZE_LOG[Year==1921] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1921])
current_prices_backcasting$NCS_AZE_LOG[Year==1923] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1923])
current_prices_backcasting$NCS_AZE_LOG[Year==1925] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1925])
current_prices_backcasting$NCS_AZE_LOG[Year==1927] <- log(current_prices_backcasting$NCS_AZE_LVL[Year==1927])
detach(current_prices_backcasting)
attach(current_prices_backcasting)
current_prices_backcasting$NCS_AZE_HP[Year==1899] <- current_prices_backcasting$NCS_AZE_LOG[Year==1899]-current_prices_backcasting$NCS_AZE_DIFF[Year==1899]
current_prices_backcasting$NCS_AZE_HP[Year==1909] <- current_prices_backcasting$NCS_AZE_LOG[Year==1909]-current_prices_backcasting$NCS_AZE_DIFF[Year==1909]
current_prices_backcasting$NCS_AZE_HP[Year==1914] <- current_prices_backcasting$NCS_AZE_LOG[Year==1914]-current_prices_backcasting$NCS_AZE_DIFF[Year==1914]
current_prices_backcasting$NCS_AZE_HP[Year==1919] <- current_prices_backcasting$NCS_AZE_LOG[Year==1919]-current_prices_backcasting$NCS_AZE_DIFF[Year==1919]
current_prices_backcasting$NCS_AZE_HP[Year==1921] <- current_prices_backcasting$NCS_AZE_LOG[Year==1921]-current_prices_backcasting$NCS_AZE_DIFF[Year==1921]
current_prices_backcasting$NCS_AZE_HP[Year==1923] <- current_prices_backcasting$NCS_AZE_LOG[Year==1923]-current_prices_backcasting$NCS_AZE_DIFF[Year==1923]
current_prices_backcasting$NCS_AZE_HP[Year==1925] <- current_prices_backcasting$NCS_AZE_LOG[Year==1925]-current_prices_backcasting$NCS_AZE_DIFF[Year==1925]
current_prices_backcasting$NCS_AZE_HP[Year==1927] <- current_prices_backcasting$NCS_AZE_LOG[Year==1927]-current_prices_backcasting$NCS_AZE_DIFF[Year==1927]
detach(current_prices_backcasting)

for (t in (2:(1928-1899+1))){
	attach(current_prices_backcasting)
	if(Year[[t]]>1899 & Year[[t]]<1909){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1909]-NCS_AZE_HP[Year==1899])/(1909-1899)
	}
	if(Year[[t]]>1909 & Year[[t]]<1914){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1914]-NCS_AZE_HP[Year==1909])/(1914-1909)
	}
	if(Year[[t]]>1914 & Year[[t]]<1919){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1919]-NCS_AZE_HP[Year==1914])/(1919-1914)
	}
	if(Year[[t]]>1919 & Year[[t]]<1921){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1921]-NCS_AZE_HP[Year==1919])/(1921-1919)
	}
	if(Year[[t]]>1921 & Year[[t]]<1923){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1923]-NCS_AZE_HP[Year==1921])/(1923-1921)
	}
	if(Year[[t]]>1923 & Year[[t]]<1925){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1925]-NCS_AZE_HP[Year==1923])/(1925-1923)
	}
	if(Year[[t]]>1925 & Year[[t]]<1927){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1927]-NCS_AZE_HP[Year==1925])/(1927-1925)
	}
	if(Year[[t]]>1927 & Year[[t]]<1929){
		current_prices_backcasting$NCS_AZE_HP[[t]] <- NCS_AZE_HP[[t-1]]+(NCS_AZE_HP[Year==1929]-NCS_AZE_HP[Year==1927])/(1929-1927)
	}
	detach(current_prices_backcasting)
}
for (t in (2:(1928-1899+1))){
	attach(current_prices_backcasting)
	if(Year[[t]]>1899 & Year[[t]]<1909){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1909 & Year[[t]]<1914){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1914 & Year[[t]]<1919){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1919 & Year[[t]]<1921){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1921 & Year[[t]]<1923){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1923 & Year[[t]]<1925){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1925 & Year[[t]]<1927){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	if(Year[[t]]>1927 & Year[[t]]<1929){
		current_prices_backcasting$NCS_AZE_LOG[[t]] <- NCS_AZE_HP[[t]]+NCS_AZE_DIFF[[t]]
	}
	detach(current_prices_backcasting)
}
for (t in (2:(1928-1899+1))){
	attach(current_prices_backcasting)
	if(Year[[t]]>1899 & Year[[t]]<1909){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1909 & Year[[t]]<1914){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1914 & Year[[t]]<1919){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1919 & Year[[t]]<1921){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1921 & Year[[t]]<1923){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1923 & Year[[t]]<1925){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1925 & Year[[t]]<1927){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	if(Year[[t]]>1927 & Year[[t]]<1929){
		current_prices_backcasting$NCS_AZE_LVL[[t]] <- exp(NCS_AZE_LOG[[t]])
	}
	detach(current_prices_backcasting)
}
current_prices_backcasting <- subset(current_prices_backcasting,select=c("Year","NCS_AZE_LVL"))

setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
load("s008.azeredo_nipa_nominal_v1.RData")

names_drop <- names(azeredo_nipa_nominal_v1) %in% c("NCS_AZE_LVL")
azeredo_nipa_nominal_v1 <- azeredo_nipa_nominal_v1[!names_drop]
azeredo_nipa_nominal_v1 <- merge(azeredo_nipa_nominal_v1,current_prices_backcasting,by="Year")

azeredo_nipa_nominal_v1$NCSPER_AZE_LVL = 1000*azeredo_nipa_nominal_v1$NCS_AZE_LVL/azeredo_nipa_nominal_v1$pop
azeredo_nipa_nominal_v1$NCSPER_AZE_LVL_LEAD=c(tail(azeredo_nipa_nominal_v1$NCSPER_AZE_LVL,-1),NA)
azeredo_nipa_nominal_v1$NCSPER_AZE_GRW=azeredo_nipa_nominal_v1$NCSPER_AZE_LVL_LEAD/azeredo_nipa_nominal_v1$NCSPER_AZE_LVL-1

attach(azeredo_nipa_nominal_v1)
azeredo_nipa_nominal_v1$NCNDSPER_AZE_LVL_GRW=(NCNDPER_AZE_LVL_LEAD+NCSPER_AZE_LVL_LEAD)/(NCNDPER_AZE_LVL+NCSPER_AZE_LVL)-1
detach(azeredo_nipa_nominal_v1)

names_drop <- names(azeredo_nipa_nominal_v1) %in% c("NCNDPER_AZE_LVL_LEAD","NCSPER_AZE_LVL_LEAD")
azeredo_nipa_nominal_v1 <- azeredo_nipa_nominal_v1[!names_drop]

# export results
setwd(paste(rootpath,"Analysis/Output",sep=""))
getwd()
sink(file="s010.service_nom_regression.txt")
summary(service_nom_regression)
sink(NULL)
save(azeredo_nipa_nominal_v1,file="s010.azeredo_nipa_nominal_v1.RData")
