%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Testing for Structural Change %
% Compute W Statistics %

clear -exclusive rootpath;
data=dlmread(strcat(rootpath,'Output\s002.consumption_traditional.csv'), ",");
[T N]= size(data);
CNDSPER_KUZ_GRW = data(2:T-1,13);

T = length(CNDSPER_KUZ_GRW);
y = CNDSPER_KUZ_GRW(2:T);
x = [ones(T-1,1), CNDSPER_KUZ_GRW(1:T-1)];
trimsup_=.15;
year = 1889:2010;
year = year';

t=length(y(:,1));
kk=length(x(1,:));
f=zeros(t,1);
trim_=trimsup_;
tr=(1:t)';
t1=round(t*trim_);
t2=round(t*(1-trim_));
e=y-x*((y'/x')'); % portion of y not explained by x;
i=t1;
while i<=t2
    d=(tr>i);
    j=kk+1;
    z=x.*(d*ones(1,length(x(1,:)))); %[0 ; x2];
    z=z-x*((z'/x')'); % z = portion of [0; x2] not explained by x;
    ze=z'*e; % covariance ;
    beta=(ze'/(z'*z)')';
    v=(z.*((e-z*beta)*ones(1,length(x(1,:)))))'*(z.*((e-z*beta)*ones(1,length(x(1,:)))));
    f(i)=(ze'/v')*ze;
    i=i+1;
end;
t1=round(t*trim_);
t2=round(t*(1-trim_));
[supf,kest]=max(f);
yearbreak=1889+kest
supf
