%% Figure eq2d
clear -exclusive rootpath;
% Inputs
mu = 0.020;
delta = 0.022;
beta = 0.98;
rho = [-0.14 0.42];
alpha = linspace(0,10,100);
% Loop
cd(strcat(rootpath,'Code'))
for i = 1:length(alpha)
    for j = 1:length(rho)
        [w, EEP(i,j), ERe, ERf, CERe, Rf, G, Re, P, p] = mpep(mu,delta,rho(j),beta,alpha(i));
    end
end
% Export/Save Results
hold on
plot(alpha, 100*EEP(:,1),   'r-.',...
                            'LineWidth',2.5)
plot(alpha, 100*EEP(:,2),   'k-',...
                            'LineWidth',2.5)
plot(alpha, zeros(length(alpha),1), 'k:',...
                                    'LineWidth',1)
hold off
xlabel('\alpha')
ylabel('Equity Premium - %')
h = legend('negative serial correlation', 'positive serial correlation',2);
legend('boxoff');
set(gcf, 'PaperPositionMode', 'auto');
cd(strcat(rootpath,'Output'))
saveas(gcf, 's016.ep2d.pdf')
close
