%% Figure ep3d: Equity Premium as a function of the CRRA coefficient and Serial Correlation
clear -exclusive rootpath;
% Inputs
mu = 0.020;
delta = 0.022;
beta = 0.98;
rho = linspace(-0.30, 0.45, 20);
alpha = linspace(0,4,20);
% Loop
cd(strcat(rootpath,'Code'))
for i = 1:length(alpha)
    for j = 1:length(rho)
        [w, EEP(i,j), ERe, ERf, CERe, Rf, G, Re, P, p] = mpep(mu,delta,rho(j),beta,alpha(i));
    end
end
% Export/Save Results
mesh(alpha,rho,100*EEP', 'FaceColor', 'black','LineStyle','-.', 'LineWidth',1.25)
axis tight
view(144,26)
shading faceted
colormap gray
%camlight(144,26)
xlabel('CRRA coefficient, \alpha')
ylabel('Serial Correlation, \rho')
zlabel('Equity Premium - %')
colorbar
set(gcf, 'PaperPositionMode', 'auto');
cd(strcat(rootpath,'Output'))
saveas(gcf, 's017.ep3d.pdf')
close
