hp <- function(Data,lb){
# HP Filter.
# Inputs: (i) Data => log series. (ii) lb => smooth parameter.
# Output: HP.
	n <- length(Data)
	K <- matrix(0,n-2,n)
	for (i in (1:n)){
		for (t in (1:n-2)){
			if(t == i){
				K[t,i] <- 1
			}
			else if (t == i-1){
				K[t,i] <- -2
			}
			else if (t == i-2){
				K[t,i] <- 1
			}
			else{
				K[t,i] <- 0
			}
		}
	}
	ID <- matrix(0,n,n)
	for (i in (1:n)){
		for (t in (1:n)){
			if (i == t){
				ID[t,i] <- 1
			}
			else{
				ID[t,i] <- 0
			}
		}
	}
	KK = t(K) %*% K
	MM <- ID + lb*KK
	hp <- solve(MM) %*% Data
	return(hp)
}